<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class LimitSharing extends \Google\Protobuf\Internal\Message
{
    


    protected $sharingLimited = null;
    


    protected $trigger = null;
    


    protected $limitSharingSettingTimestamp = null;
    


    protected $initiatedByMe = null;

    











    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getSharingLimited()
    {
        return isset($this->sharingLimited) ? $this->sharingLimited : false;
    }

    public function hasSharingLimited()
    {
        return isset($this->sharingLimited);
    }

    public function clearSharingLimited()
    {
        unset($this->sharingLimited);
    }

    




    public function setSharingLimited($var)
    {
        GPBUtil::checkBool($var);
        $this->sharingLimited = $var;

        return $this;
    }

    



    public function getTrigger()
    {
        return isset($this->trigger) ? $this->trigger : 0;
    }

    public function hasTrigger()
    {
        return isset($this->trigger);
    }

    public function clearTrigger()
    {
        unset($this->trigger);
    }

    




    public function setTrigger($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\LimitSharing\TriggerType::class);
        $this->trigger = $var;

        return $this;
    }

    



    public function getLimitSharingSettingTimestamp()
    {
        return isset($this->limitSharingSettingTimestamp) ? $this->limitSharingSettingTimestamp : 0;
    }

    public function hasLimitSharingSettingTimestamp()
    {
        return isset($this->limitSharingSettingTimestamp);
    }

    public function clearLimitSharingSettingTimestamp()
    {
        unset($this->limitSharingSettingTimestamp);
    }

    




    public function setLimitSharingSettingTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->limitSharingSettingTimestamp = $var;

        return $this;
    }

    



    public function getInitiatedByMe()
    {
        return isset($this->initiatedByMe) ? $this->initiatedByMe : false;
    }

    public function hasInitiatedByMe()
    {
        return isset($this->initiatedByMe);
    }

    public function clearInitiatedByMe()
    {
        unset($this->initiatedByMe);
    }

    




    public function setInitiatedByMe($var)
    {
        GPBUtil::checkBool($var);
        $this->initiatedByMe = $var;

        return $this;
    }

}

